<!--#include file="settings.asp"-->
<!--#include file="subs/utilFunctions.asp"-->

<!--#include file="subs/permissions.asp"-->
<!--#include file="language/language.asp"-->


<%
'---------------------------------------------------------------------
' utilFunctions.asp  : getNumber, checkHTMLString functions
'---------------------------------------------------------------------

'---------------------------------------------------------------------
if session("goLogin")<>"no" then
	set storeConn = nothing
	response.redirect "default.asp"
end if
'---------------------------------------------------------------------
call shippingPermissions()
if SHIPPING_MODULE = MODULE_NOT_AVAILABLE then
	set storeConn = nothing
	session("errMessage") = You_have_no_permission_to_use_this_module_CONST
	response.redirect "error.asp"
end if
'---------------------------------------------------------------------

dim whoCall

dim storeRS, sqlString
dim shippingID, shippingName, country, region
dim priceInferiorMargin, priceSuperiorMargin
dim weightInferiorMargin, weightSuperiorMargin
dim baseFee, priceFee, weightFee

' ----------------------------------- for UPS -------------------------------------
dim licenceNumber, userID, password, zipCode, pickupType, serviceCode, packageType, countryCode, upsServer, upsCity
'------------------------------------ for FeDex -----------------------------------
dim fedexAccountNumber, fedexMeterNumber, zipCode2, countryCode2, regionCode2, fedexServer
dim fedexCarrierCode, fedexDropoffType, fedexServiceList, fedexPackaging
'------------------------------------ for USPS -----------------------------------
dim userID3, password3, zipCode3, uspsServer
'------------------------------------ for DHL -----------------------------------
dim zipCode4, countryCode4, dhlServer

Set storeRS = Server.CreateObject("ADODB.Recordset")
whoCall = trim(request.form("whoCall"))
select case whoCall

case "shippingAddEdit"
	shippingName = trim(checkHTMLString(request.form("shippingName")))
	country = trim(request.form("country"))
	if instr(country,"all")>0 then
		country = "all"
	end if
	region = trim(request.form("region"))
	if instr(region, "noShipping")>0 then
		region = "noShipping"
	elseif instr(region, "all")>0 then
		region = "all"
	end if
	
	baseFee = trim(request.form("baseFee"))
	if baseFee <> "" then
		if not getNumber(baseFee, baseFee) then
			set storeConn = nothing
			session("errMessage") = "Please enter a numerical Base fee!"
			response.redirect "error.asp"
		end if
	else
		baseFee = 0
	end if
	
	priceInferiorMargin = trim(request.form("priceInferiorMargin"))
	if priceInferiorMargin <> "" then
		if not getNumber(priceInferiorMargin,priceInferiorMargin) then
			set storeConn = nothing
			session("errMessage") = "Please enter a numerical Price Inferior limit!"
			response.redirect "error.asp"
		end if
	else
		priceInferiorMargin = 0
	end if
	
	priceSuperiorMargin = trim(request.form("priceSuperiorMargin"))
	if priceSuperiorMargin <> "" then
		if not getNumber(priceSuperiorMargin, priceSuperiorMargin) then
			set storeConn = nothing
			session("errMessage") = "Please enter a numerical Price Superior limit!"
			response.redirect "error.asp"
		end if
	else
		priceSuperiorMargin = 0
	end if
	
	priceFee = trim(request.form("priceFee"))
	if priceFee <> "" then
		if not getNumber(priceFee,priceFee) then
			set storeConn = nothing
			session("errMessage") = "Please enter a numerical Price fee!"
			response.redirect "error.asp"
		end if
	else
		priceFee = 0
	end if
	
	weightInferiorMargin = trim(request.form("weightInferiorMargin"))
	if weightInferiorMargin<>"" then
		if not getNumber(weightInferiorMargin, weightInferiorMargin) then
			set storeConn = nothing
			session("errMessage") = "Please enter a numerical Weight Inferior limit!"
			response.redirect "error.asp"
		end if
	else
		weightInferiorMargin = 0
	end if
	
	weightSuperiorMargin = trim(request.form("weightSuperiorMargin"))
	if weightSuperiorMargin<>"" then
		if not getNumber(weightSuperiorMargin, weightSuperiorMargin) then
			set storeConn = nothing
			session("errMessage") = "Please enter a numerical Weight Superior limit!"
			response.redirect "error.asp"
		end if
	else
		weightSuperiorMargin = 0
	end if
	
	weightFee = trim(request.form("weightFee"))
	if weightFee<>"" then
		if not getNumber(weightFee , weightFee) then
			set storeConn = nothing
			session("errMessage") = "Please enter a numerical Weight fee!"
			response.redirect "error.asp"
		end if
	else
		weightFee = 0
	end if
	
	shippingID = trim(request.form("shippingID"))
	if not testUrl(shippingID, errMessage) then
		set storeConn = nothing
		session("errMessage") = errMessage
		response.redirect "error.asp"
	end if
	if shippingID = "" then 'add a record
		sqlString = "select shippingID from storeShipping where storeID="&storeID
		storeRS.open sqlString, storeConn, 1, 1
		if storeRS.eof then
			shippingID = 1
		else
			storeRS.close
			sqlString = "select max(shippingID) as maxShippingID from storeShipping where storeID="&storeID
			storeRS.open sqlString, storeConn, 1, 1
			shippingID = cint(storeRS("maxShippingID"))+1
		end if
		storeRS.close
		setlocale("en-us")
		sqlString = "insert into storeShipping (shippingID,storeID,shippingName,country,region,baseFee," &_
				    "priceInferiorMargin,priceSuperiorMargin,priceFee,weightInferiorMargin,weightSuperiorMargin,weightFee) values " &_
				    "("&shippingID&","&storeID&",'"&shippingName&"','"&country&"','"&region&"',"&baseFee&","&priceInferiorMargin &_
				    ","&priceSuperiorMargin&","&priceFee&","&weightInferiorMargin&","&weightSuperiorMargin&","&weightFee&")"
		if SHIPPING_MODULE = MODULE_WRITING then
			runSQL(sqlString)
		end if
		setlocale(storeLocaleID)
		set storeRS = nothing
		set storeConn = nothing
		response.redirect "shippingList.asp?done=yes"
	else 'update a record
		setlocale("en-us")
		sqlString = "update storeShipping set shippingName='"&shippingName&"',country='"&country&"',region='"&region&"'," &_
				    "baseFee="&baseFee &_  
				    ",priceInferiorMargin="&priceInferiorMargin&",priceSuperiorMargin="&priceSuperiorMargin&",priceFee="&priceFee &_
				    ",weightInferiorMargin="&weightInferiorMargin&",weightSuperiorMargin="&weightSuperiorMargin&",weightFee="&weightFee &_
				    " where storeID="&storeID&" and shippingID="&shippingID
		if SHIPPING_MODULE = MODULE_WRITING then
			runSQL(sqlString)
		end if
		setlocale(storeLocaleID)
		set storeRS = nothing
		set storeConn = nothing
		response.redirect "shippingList.asp?done=yes"
	end if			
		
case "shippingList"
	if trim(request.form("realTimeShipping")) <> "" then
		sqlString = "update storeShippingRealTime set enabled = -1 where storeID = "&storeID&" and shippingMethodID = 0"
		if SHIPPING_MODULE = MODULE_WRITING then
			runSQL(sqlString)
		end if
	else
		sqlString = "update storeShippingRealTime set enabled = 0 where storeID = "&storeID&" and shippingMethodID = 0"
		if SHIPPING_MODULE = MODULE_WRITING then
			runSQL(sqlString)
		end if
	end if
	if trim(request.form("ups")) <> "" then
		licenceNumber = checkHTMLString(trim(request.form("licenceNumber")))
		userID = checkHTMLString(trim(request.form("userID")))
		password = checkHTMLString(trim(request.form("password")))
		zipCode = checkHTMLString(trim(request.form("zipCode")))
		countryCode = checkHTMLString(trim(request.form("countryCode")))
		pickupType = checkHTMLString(trim(request.form("pickupType")))
		serviceCode = checkHTMLString(trim(request.form("serviceCode")))
		packageType = checkHTMLString(trim(request.form("packageType")))
		upsServer = checkHTMLString(trim(request.form("upsServer")))
		upsCity = checkHTMLString(trim(request.form("upsCity")))
		sqlString = "update storeShippingRealTime set enabled = -1, property1 = '"&licenceNumber&"', property2 = '"&userID&"', " &_
					"property3 = '"&password&"', property4 = '"&zipCode&"', property5 = '"&pickupType&"', " &_
					"property6 = '"&serviceCode&"', property7 = '"&packageType&"', property8 = '"&countryCode&"', property9 = '"&upsServer&"', property10 = '"&upsCity&"' where storeID = "&storeID&" and shippingMethodID = 1"
		if SHIPPING_MODULE = MODULE_WRITING then
			runSQL(sqlString)
		end if
	else
		sqlString = "update storeShippingRealTime set enabled = 0 where storeID = "&storeID&" and shippingMethodID = 1"
		if SHIPPING_MODULE = MODULE_WRITING then
			runSQL(sqlString)
		end if
	end if
	if trim(request.form("fedex")) <> "" then
		fedexAccountNumber = checkHTMLString(trim(request.form("fedexAccountNumber")))
		fedexMeterNumber = checkHTMLString(trim(request.form("fedexMeterNumber")))
		zipCode2 = checkHTMLString(trim(request.form("zipCode2")))
		countryCode2 = checkHTMLString(trim(request.form("countryCode2")))
		regionCode2 = checkHTMLString(trim(request.form("regionCode2")))
		fedexCarrierCode = checkHTMLString(trim(request.form("fedexCarrierCode")))
		fedexServiceList = checkHTMLString(trim(request.form("fedexServiceList")))
		fedexDropoffType = checkHTMLString(trim(request.form("fedexDropoffType")))
		fedexPackaging = checkHTMLString(trim(request.form("fedexPackaging")))
		fedexServer = checkHTMLString(trim(request.form("fedexServer")))
		sqlString = "update storeShippingRealTime set enabled = -1, property1 = '"&fedexAccountNumber&"', property2 = '"&fedexMeterNumber&"', property3 = '"&fedexDropoffType&"', " &_
					"property4 = '"&zipCode2&"', property5 = '"&fedexCarrierCode&"', property6 = '"&fedexServiceList&"', property7 = '"&fedexPackaging&"', " &_
					"property8 = '"&countryCode2&"', property9 = '"&fedexServer&"', property10 = '"&regionCode2&"' where storeID = "&storeID&" and shippingMethodID = 2"
		if SHIPPING_MODULE = MODULE_WRITING then
			runSQL(sqlString)
		end if
	else
		sqlString = "update storeShippingRealTime set enabled = 0 where storeID = "&storeID&" and shippingMethodID = 2"
		if SHIPPING_MODULE = MODULE_WRITING then
			runSQL(sqlString)
		end if
	end if
	if trim(request.form("usps")) <> "" then
		zipCode3 = checkHTMLString(trim(request.form("zipCode3")))
		userID3 = checkHTMLString(trim(request.form("userID3")))
		password3 = checkHTMLString(trim(request.form("password3")))
		uspsServer = checkHTMLString(trim(request.form("uspsServer")))
		sqlString = "update storeShippingRealTime set enabled = -1, property1 = '"&userID3&"', property2 = '"&password3&"', property3 = '"&zipCode3&"', property9 = '"&uspsServer&"' where storeID = "&storeID&" and shippingMethodID = 3"
		if SHIPPING_MODULE = MODULE_WRITING then
			runSQL(sqlString)
		end if
	else
		sqlString = "update storeShippingRealTime set enabled = 0 where storeID = "&storeID&" and shippingMethodID = 3"
		if SHIPPING_MODULE = MODULE_WRITING then
			runSQL(sqlString)
		end if
	end if
	if trim(request.form("dhl")) <> "" then
		zipCode4 = checkHTMLString(trim(request.form("zipCode4")))
		countryCode4 = checkHTMLString(trim(request.form("countryCode4")))
		sqlString = "update storeShippingRealTime set enabled = -1, property1 = '"&zipCode4&"', property2 = '"&countryCode4&"' where storeID = "&storeID&" and shippingMethodID = 4"
		if SHIPPING_MODULE = MODULE_WRITING then
			runSQL(sqlString)
		end if
	else
		sqlString = "update storeShippingRealTime set enabled = 0 where storeID = "&storeID&" and shippingMethodID = 4"
		if SHIPPING_MODULE = MODULE_WRITING then
			runSQL(sqlString)
		end if
	end if

	set storeConn = nothing
	response.redirect "shippingList.asp?done=yes"
			
case "" 'delete a shipping method
	shippingID = request.queryString("shippingID")
	if not testUrl(shippingID, errMessage) then
		set storeConn = nothing
		session("errMessage") = errMessage
		response.redirect "error.asp"
	end if
	sqlString = "delete from storeShipping where shippingID = "&shippingID&" and storeID = "&storeID
	if SHIPPING_MODULE = MODULE_WRITING then
		runSQL(sqlString)
	end if
	set storeConn = nothing
	response.redirect "shippingList.asp"
		
end select
%>
