<%
'------------ The following functions are using for predefined shipping methods ------------
function calculateShipping(methodID, listProducts)

dim theResult, storeLocal,storeLocal2, sqlString
dim baseFee,priceFee,weightFee
dim priceInferiorMargin,priceSuperiorMargin,weightInferiorMargin,weightSuperiorMargin
dim totalPriceInCart,totalWeightInCart
dim shippingProduct

theResult = "" 
Set storeLocal = Server.CreateObject("ADODB.Recordset")
Set storeLocal2 = Server.CreateObject("ADODB.Recordset")
sqlString = "select baseFee, priceInferiorMargin, priceSuperiorMargin, priceFee, weightInferiorMargin, weightSuperiorMargin, weightFee from storeShipping where shippingID="&methodID&" and storeID="&storeID
storeLocal.open sqlString, storeConn, 1, 1
baseFee = cdbl(storeLocal("baseFee"))
priceFee = cdbl(storeLocal("priceFee"))
weightFee = cdbl(storeLocal("weightFee"))
priceInferiorMargin = cdbl(storeLocal("priceInferiorMargin"))
priceSuperiorMargin = cdbl(storeLocal("priceSuperiorMargin"))
weightInferiorMargin = cdbl(storeLocal("weightInferiorMargin"))
weightSuperiorMargin = cdbl(storeLocal("weightSuperiorMargin"))
storeLocal.close

'--------------------calculate the value for priceFee--------------------------
if priceInferiorMargin <> 0 or priceSuperiorMargin <> 0 then 'the metod include priceFee
	sqlString="select customerCartID, totalPriceInCart, stepSale from storeCustomersCart where userID='"&userID&"' and storeID="&storeID
	storeLocal.open sqlString, storeConn, 1, 1
	totalPriceInCart = 0
	do while not storeLocal.eof
		if instr(" "&listProducts&","," "&storeLocal("customerCartID")&",")>0 then
			totalPriceInCart = totalPriceInCart + cdbl(storeLocal("totalPriceInCart"))*cdbl(storeLocal("stepSale"))
		end if
		storeLocal.movenext
	loop
	storeLocal.close
	if totalPriceInCart >= priceInferiorMargin and totalPriceInCart <= priceSuperiorMargin then
		priceFee = priceFee*totalPriceInCart/100
	else
		calculateShipping=-1
		exit function
	end if
end if
'--------------------calculate the value for weightFee --------------------------
if weightInferiorMargin<>0 or weightSuperiorMargin <> 0 then 'the metod include weightFee and 
	sqlString = "select customerCartID, productID, quantity, productWeight from storeCustomersCart where userID='"&userID&"' and storeID="&storeID
	storeLocal.open sqlString, storeConn, 1, 1
	totalWeightInCart = 0
	do while not storeLocal.eof
		if instr(" "&listProducts&","," "&storeLocal("customerCartID")&",")>0 then
			totalWeightInCart = totalWeightInCart + cdbl(storeLocal("quantity")) * cdbl(storeLocal("productWeight"))
		end if
		storeLocal.movenext
	loop
	storeLocal.close
	if totalWeightInCart >= weightInferiorMargin and totalWeightInCart <= weightSuperiorMargin then
		weightFee = weightFee * totalWeightInCart / 100
	else
		calculateShipping = -1
		exit function
	end if
end if

'------------calculate the special shipping for the product (if the product is periasable, etc)-----------------------------
sqlString = "select customerCartID, productID, quantity from storeCustomersCart where userID='"&userID&"' and storeID="&storeID
storeLocal.open sqlString, storeConn, 1, 1
shippingProduct = 0
do while not storeLocal.eof
	if instr(" "&listProducts&","," "&storeLocal("customerCartID")&",")>0 then
		sqlString = "select shippingPrice from storeProducts where storeID="&storeID&" and productID="&storeLocal("productID")
		storeLocal2.open sqlString, storeConn, 1, 1
		shippingProduct = shippingProduct + cdbl(storeLocal("quantity"))*cdbl(storeLocal2("shippingPrice"))
		storeLocal2.close
	end if
	storeLocal.movenext
loop
storeLocal.close
set storeLocal = nothing
set storeLocal2 = nothing

calculateShipping = baseFee + priceFee + weightFee + shippingProduct

end function
'-----------------------------------------------------------------------------

sub testAdressShipping(shippingAdress, listProducts, listShippingMethods, listShippingPrices)

'input values :
	'customerID -> the id of the customer
	'shippingAdress -> the id adress for shipping
	'listProducts -> theList with the customerCartID values (the autonumber values from storeCustomersCart table); not the productID field !
'output values :
	'listShippingMethods - > the list with all valid methods (ids) (Ex: 1,3,5)
	'listShippingPrices - > the list with all taxes from all valid methods (Ex: 10,0,5)

dim okCalculate
dim priceForMethod

dim storeLocal,storeAdress, sqlString
dim regionCustomer, countryCustomer

Set storeLocal = Server.CreateObject("ADODB.Recordset")	
Set storeAdress = Server.CreateObject("ADODB.Recordset")	
sqlString = "select country, region from storeCustomersAddresses where custID = "&customerID&" and addrType='"&shippingAdress&"' and storeID = "&storeID
storeLocal.open sqlString, storeConn, 1, 1

'calculate the regionID
if storeLocal("region")<> "Other" then
	sqlString = "select regionID from systemRegions where region='"&storeLocal("region")&"' and storeID = "&storeID
	storeAdress.open sqlString, storeConn, 1, 1
	regionCustomer = storeAdress("regionID")
	storeAdress.close
else
	regionCustomer = "Other"
end if
'calculate the countryID
sqlString = "select countryID from systemCountries where country='"&storeLocal("country")&"'"
storeAdress.open sqlString, storeConn, 1, 1
countryCustomer = storeAdress("countryID")
storeAdress.close
set storeAdress = nothing

storeLocal.close

sqlString = "select shippingID, shippingName, country, region from storeShipping where storeID="&storeID
storeLocal.open sqlString, storeConn, 1, 1
do while not storeLocal.eof
	okCalculate = false
	if storeLocal("country") = "all" then
		okCalculate = true
	else
		if instr(" "&storeLocal("country")&","," "&countryCustomer&",")>0 then	
			' test the regions
			if storeLocal("region") = "noShipping" or storeLocal("region") = "all" then
				okCalculate = true
			else
				if instr(" "&storeLocal("region")&","," "&regionCustomer&",")>0 then	
					okCalculate = true
				end if
			end if
		end if
	end if
	if okCalculate then
		priceForMethod = cdbl(calculateShipping(storeLocal("shippingID"),listProducts))
		if priceForMethod <> -1 then
			if listShippingMethods = "" then
				listShippingMethods = storeLocal("shippingName")
				listShippingPrices = cstr(priceForMethod)
			else
				listShippingMethods = listShippingMethods&","&storeLocal("shippingName")
				listShippingPrices = listShippingPrices&"}"&cstr(priceForMethod)
			end if
		end if
	end if
	storeLocal.movenext
loop
storeLocal.close
set storeLocal = nothing
end sub
'-----------------------------------------------------------------------------

function calculateTax(listCustomerCartID,shippingTax)

dim storeLocal, storeAdress, storeCart, storeProduct
dim sqlString
dim country,region

dim totalTax, totalPriceInCart
dim okCalculate

totalTax = 0
Set storeLocal = Server.CreateObject("ADODB.Recordset")
Set storeAdress = Server.CreateObject("ADODB.Recordset")

sqlString = "select country,region from storeCustomersAddresses where custID="&customerID&" and addrType='B' and storeID = "&storeID
storeLocal.open sqlString, storeConn, 1, 1

'calculate the countryID
sqlString = "select countryID from systemCountries where country='"&storeLocal("country")&"'"
storeAdress.open sqlString, storeConn, 1, 1
country = storeAdress("countryID")
storeAdress.close

'calculate the regionID
if storeLocal("region")<>"Other" then
	sqlString = "select regionID from systemRegions where region='"&storeLocal("region")&"' and storeID = "&storeID
	storeAdress.open sqlString, storeConn, 1, 1
	region = storeAdress("regionID")
	storeAdress.close
else
	region = "Other"
end if
storeLocal.close
set storeAdress = nothing

sqlString = "select country, region, category, modeCalculate, tax from storeTaxes where storeID="&storeID
storeLocal.open sqlString, storeConn, 1, 1
if storeLocal.eof then
	storeLocal.close
	set storeLocal = nothing
	calculateTax = totalTax
	exit function
end if
do while not storeLocal.eof
	okCalculate = false
	if storeLocal("country") = "all" then
		okCalculate = true
	else
		if instr(" "&storeLocal("country")&","," "&country&",")>0 then
			' test the regions
			if storeLocal("region") = "noTaxes" or storeLocal("region") = "all" then
				okCalculate = true
			else
				if instr(" "&storeLocal("region")&","," "&region&",")>0 then
					okCalculate = true
				end if
			end if
		end if
	end if
	if okCalculate then
		totalPriceInCart = 0
		sqlString = "select customerCartID, productID, totalPriceInCart, stepSale from storeCustomersCart where storeID="&storeID&" and userID='"&userID&"'"
		Set storeCart = Server.CreateObject("ADODB.Recordset")
		storeCart.open sqlString, storeConn, 1, 1
		do while not storeCart.eof
			if instr(" "&listCustomerCartID&","," "&storeCart("customerCartID")&",") > 0 or listCustomerCartID = "all" then
				sqlString = "select productName, categoryID, taxFree from storeProducts where storeID = "&storeID&" and productID = "&storeCart("productID")
				set storeProduct = Server.CreateObject("ADODB.Recordset")
				storeProduct.open sqlString, storeConn, 1, 1
				if not storeProduct("taxFree") then
					'test if category product is included in categories of taxes
					if instr(" "&storeLocal("category")&","," "&storeProduct("categoryID")&",")>0 or storeLocal("category")="all" then
						totalPriceInCart = totalPriceInCart + cdbl(storeCart("totalPriceInCart")) * cdbl(storeCart("stepSale"))
					end if
				end if
				storeProduct.close
				set storeProduct = nothing
			end if
			storeCart.movenext
		loop
		'calculate the tax
		if totalPriceInCart<>0 then
			if storeLocal("modeCalculate") then 'tax = tax procent * total price /100
				totalTax = totalTax + totalPriceInCart * cdbl(storeLocal("tax"))/100
			else 
				totalTax = totalTax+(totalPriceInCart + shippingTax) * cdbl(storeLocal("tax"))/100
			end if
		end if
		storeCart.close
		set storeCart = nothing
	end if
	storeLocal.movenext
loop

set storeLocal = nothing
calculateTax = totalTax

end function

'-----------------------------------------------------------------------------
'The following function is using to return total weight for the cart (used in Real Time shipping methods)
sub getTotalWeightCart(listProducts, totalWeight, weightUnit)
	'listProducts -> the IDs of products from storeCustomersCart table
	'the locale settings must be "en-us" when this function is called

	dim storeLocal, sqlString
	dim stepSale
	
	totalWeight = 0
	weightUnit = ""
	sqlString = "select customerCartID, productID, quantity, productWeight, productMeasure, stepSale from storeCustomersCart where userID='"&userID&"' and storeID="&storeID
	set storeLocal = Server.CreateObject("ADODB.Recordset")
	storeLocal.open sqlString, storeConn, 1, 1
	do while not storeLocal.eof
		if instr(" "&listProducts&","," "&storeLocal("customerCartID")&",") > 0 then
			'-------------- calculate the weight for each product --------------
			'stepSale = cdbl(storeLocal("stepSale"))
			'if stepSale = int(stepSale) then
			'	totalWeight = totalWeight + cdbl(storeLocal("productWeight")) * stepSale
			'else
			totalWeight = totalWeight + cdbl(storeLocal("quantity")) * cdbl(storeLocal("productWeight"))
			'end if
			'-------------- calculate the unit measure for each product -------------- 
			if storeLocal("productMeasure") = "" then
				weightUnit = "LBS"
			else
				if ucase(storeLocal("productMeasure")) <> "LBS" and ucase(storeLocal("productMeasure")) <> "KGS" then
					weightUnit = "LBS"
				else
					weightUnit = ucase(storeLocal("productMeasure"))
				end if
			end if
			'----------------------------------------------------------------------
		end if
		storeLocal.movenext
	loop
	storeLocal.close
	set storeLocal = nothing
	
	if totalWeight = 0 then
		totalWeight = 1
	end if

end sub
'-----------------------------------------------------------------------------
sub getUserAddress(userAddress, userCountry, userRegion, userCity, userZip, returnCountryCode, returnRegionCode)
	'returnCountryCode = true -> userCountry = country code; else -> userCountry = country name
	'returnRegionCode = true -> userRegion = region code; else -> userRegion = region name

	dim storeLocal, sqlString
	dim localCountry, localRegion
	
	set storeLocal = Server.CreateObject("ADODB.Recordset")
	sqlString = "select country, region, city, zip from storeCustomersAddresses where custID="&customerID&" and addrType='"&userAddress&"' and storeID = "&storeID
	storeLocal.open sqlString, storeConn, 1, 1
	if storeLocal.eof then
		storeLocal.close
		set storeLocal = nothing
		exit sub
	end if
	userCity = storeLocal("city")
	userZip = storeLocal("zip")
	localCountry = storeLocal("country")
	localRegion = storeLocal("region")
	storeLocal.close
	if returnCountryCode then
		sqlString = "select countryCode from systemCountries where country = '"&localCountry&"'"
		storeLocal.open sqlString, storeConn, 1, 1
		if not storeLocal.eof then
			userCountry = storeLocal("countryCode")
		else
			userCountry = localCountry
		end if
		storeLocal.close
	else
		userCountry = localCountry
	end if
	if returnRegionCode then
		sqlString = "select regionCode from systemRegions where storeID = "&storeID&" and region = '"&localRegion&"'"
		storeLocal.open sqlString, storeConn, 1, 1
		if not storeLocal.eof then
			if not isNull(storeLocal("regionCode")) and storeLocal("regionCode") <> "" then
				userRegion = storeLocal("regionCode")
			else
				userRegion = localRegion
			end if
		else
			userRegion = localRegion
		end if
		storeLocal.close
	else
		userRegion = localRegion
	end if
	set storeLocal = nothing

end sub
%>
