<!--#include file="../subs/browseFunctions.asp"-->
<!--#include file="../subs/browseCategFunctions.asp"-->
<!--#include file="../subs/design.asp"-->

<% 	
'---------------------------------------------------------------------
	' browseFunctions.asp : goToRecord, displayCategoryChild, drawLine, displayCategory, paginationPage functions
'---------------------------------------------------------------------

' -----------------------------------------------------------------------------------
	dim font, fontSize, fontColor, fontID, font2, fontSize2, fontColor2, fontID2, linkFont, linkSize, linkColor
	dim fontString, fontString2, linkStart, linkEnd
' -----------------------------------------------------------------------------------

	dim storeRS
	dim lineCategory, viewButtons, pageCategory, viewCategoryBar
	dim currentRecordInPage, startRecord, currentRecord
	dim categoryToDisplay, totalRecords
	dim index
	
	dim categoryID, categoryName, categoryImageID, categoryDescription, subCategories
	
'---------------------------------------------------------------------	
	call returnStyle(font, fontSize, fontColor, fontID, font2, fontSize2, fontColor2, fontID2, linkFont, linkSize, linkColor, "", "")
	if fontID = "" then
		fontString = "<font face="""&font&""" size="""&fontSize&""" color="""&fontColor&""">"
	else
		fontString = "<font id="""&fontID&""">"
	end if
	if fontID2 = "" then
		fontString2 = "<font face="""&font2&""" size="""&fontSize2&""" color="""&fontColor2&""">"
	else
		fontString2 = "<font id="""&fontID2&""">"
	end if
	if linkFont <> "" then
		linkStart = "<font face="""&linkFont&""" size="""&linkSize&""" color="""&linkColor&""">"
		linkEnd = "</font>"
	end if
'---------------------------------------------------------------------	
	Set storeRS = Server.CreateObject("ADODB.Recordset")
'---------------------------------------------------------------------
	 'calculate the values for displaying the categories
	sqlString = "select viewButtons, pageCategory, lineCategory, viewCategoryBar from storeSettings where storeID="&storeID
	storeRS.open sqlString, storeConn, 1, 1
	lineCategory = storeRS("lineCategory")
	viewButtons = storeRS("viewButtons")
	pageCategory=storeRS("pageCategory")
	viewCategoryBar = storeRS("viewCategoryBar")
	storeRS.close
'---------------------------------------------------------------------

	currentRecordInPage = 0
	startRecord = request.querystring("startRecord")
	if not testUrl(startRecord, errMessage) then
		session("errorMessage") = errMessage
		set storeRS = nothing
		set storeConn = nothing
		response.redirect "error.asp?viewID=7"
	end if
		
	if startRecord = "" then
		'doesn't exist pagination
		startRecord = 0
		currentRecord=0
	else
		currentRecord=startRecord
		if currentRecord mod pageCategory <>0 then
			currentRecord = 0
		end if
	end if
		
	' ------------------- Calculate the total number of records ----------------------------------
	categoryID = request.queryString("categoryID")
	if not testUrl(categoryID, errMessage) then
		set storeRS = nothing
		set storeConn = nothing	
		response.redirect "error.asp?viewID=7"
	end if
	if categoryID = "" then
		sqlString = "select categoryID from storeCategories where parentCategory = 0 and storeID = "&storeID
		storeRS.open sqlString, storeConn, 1, 1
		if not storeRS.eof then
			categoryToDisplay = storeRS("categoryID")
		end if
		storeRS.close
		' calculate the number of subcategories; this is important to paginate the page
		sqlString = " select count(categoryID) as total from storeCategories where parentCategory = "&categoryToDisplay&" and storeID = "&storeID 
		storeRS.open sqlString, storeConn, 1, 1
		totalRecords = storeRS("total")
		storeRS.close
	else
		categoryToDisplay = categoryID
		' test if the user didn't modified the query string
		sqlString = "select categoryID from storeCategories where storeID = "&storeID&" and categoryID = "&categoryToDisplay
		storeRS.open sqlString,storeConn,1,1
		if storeRS.eof then
			sqlString = "select categoryID from storeCategories where parentCategory = 0 and storeID = "&storeID
			storeRS.close
			storeRS.open sqlString, storeConn, 1, 1
			categoryToDisplay = storeRS("categoryID")
		end if
		storeRS.close
		' calculate the number of subcategories; this is important to paginate the page
		sqlString = " select count(categoryID) as total from storeCategories where parentCategory = "&categoryToDisplay&" and storeID = "&storeID 
		storeRS.open sqlString, storeConn, 1, 1
		totalRecords=storeRS("total")
		storeRS.close
	end if
	' -----------------------------------------------------------------------------------

	sqlString = "select categoryID, categoryName, categoryImageId, categoryDescription from storeCategories where storeID = "&storeID&" and parentCategory = " &categoryToDisplay&" order by positionInStore"
	storeRS.open sqlString, storeConn, 1, 1 

	' if exist pagination
	if currentRecord<>0 then
		call goToRecord(storeRS,currentRecord)
	end if 
%>

<table border="0" width="100%" cellspacing="0" cellpadding="0">
<% if viewCategoryBar then %>
	<tr>
		<td colspan="<%= lineCategory %>">
		<% call displayCategoryChild(categoryToDisplay) %>
		</td>
	</tr>
	<tr>
		<td colspan="<%= lineCategory %>"><br></td>
	</tr>
<% end if
do while currentRecordInPage < pageCategory
	if storeRS.eof then
		exit do
	end if
	response.write "<tr>"
	for index = 1 to lineCategory 
		if storeRS.eof or currentRecordInPage >= pageCategory then
			if currentRecordInPage >= lineCategory then
				response.write "<td><br></td>"
			end if 
		else 
			categoryID = storeRS("categoryID")
			categoryName = storeRS("categoryName")
			categoryImageID = storeRS("categoryImageID")
			categoryDescription = storeRS("categoryDescription")
			subCategories = existSubCategories(categoryID) %>
			<td valign="top">
				<table border="0" cellspacing="1" cellpadding="1">
					<tr>
						<td><!--#include file="../Design/Store/browseCategories.asp"--></td>
					</tr>
					<tr>
						<td><% call displayButtons(viewButtons, subCategories, categoryID) %></td>
					</tr>
				</table>
			</td>
			<% storeRS.movenext 
		end if
		currentRecordInPage = currentRecordInPage+1
	next
	response.write "</tr>"
loop
storeRS.close %>
<tr>
	<td colspan="<%= lineCategory %>"><br></td>
</tr>
<tr>
	<td colspan="<%= lineCategory %>"><% call paginationPage(categoryToDisplay, lineCategory, pageCategory, totalRecords, startRecord, 0) %></td>
</tr>
</table>
<% set storeRS = nothing %>

